#include <stdio.h>
#include <stdlib.h>

typedef struct _razlomak{
    int br, naz;
    struct _razlomak *next;
}razlomak;

/*Funkcija vraca pokazivac na n-ti element vezane liste*/
razlomak* trazi_element(razlomak* first, int n)
{
    while(first && --n){
        first=first->next;
    }

    return first;
}

razlomak* stvori_listu(int n)
{
    int i;
    razlomak *first=NULL, *last, *new;

    /*Klasican argument kreiranja vezane liste*/
    for(i=1; i<=n; i++){
        new=(razlomak*)malloc(sizeof(razlomak));
        new->br=1;
        new->naz=i;

        if(!first){
            last=first=new;
        }
        else{
            last=last->next=new;
        }
    }
    last->next=NULL;

    return first;
}

void ispisi_listu(razlomak* first)
{
    while(first){
        printf("%d/%d ", first->br, first->naz);
        first=first->next;
    }
    printf("\n");
}

/*Da rasteretimo glavni program*/
void izbrisi_listu(razlomak* first)
{
    razlomak* pom;

    for(;first;first=pom){
        pom=first->next;
        free(first);
    }
}

int main(void)
{
    razlomak* first, *pom;

    first=stvori_listu(10);
    ispisi_listu(first);

    pom=trazi_element(first,6);
    pom->br=4;
    pom->naz=3;
    ispisi_listu(first);

    izbrisi_listu(first);

    return 0;
}
