#include <stdio.h>
#include <stdlib.h>

typedef struct _razlomak{
    int br, naz;
    struct _razlomak *next;
}razlomak;

razlomak* unija(razlomak* a, razlomak* b)
{
    razlomak *first=NULL, *last, *temp;
    int exp1, exp2;

    while(a && b){
        exp1=a->br*b->naz;
        exp2=a->naz*b->br;

        if(exp1==exp2){
            temp=b;
            if(!first)
                last=first=a;
            else
                last=last->next=a;
            a=a->next;
            b=b->next;
            free(temp);
        }
        else if(exp1<exp2){
            if(!first)
                last=first=a;
            else
                last=last->next=a;
            a=a->next;
        }
        else{
            if(!first)
                last=first=b;
            else
                last=last->next=b;
            b=b->next;
        }
    }

    if(a){
        if(!first)
            first=a;
        else
            last->next=a;
    }
    if(b){
        if(!first)
            first=b;
        else
            last->next=b;
    }

    return first;
}

razlomak* stvori_listu()
{
    int i;
    razlomak *first=NULL, *last, *new;
    int x, y;

    /*Klasican argument kreiranja vezane liste*/
    while(1){
        scanf("%d %d", &x, &y);
        if(!y)
            break;

        new=(razlomak*)malloc(sizeof(razlomak));
        new->br=x;
        new->naz=y;

        if(!first){
            last=first=new;
        }
        else{
            last=last->next=new;
        }
    }
    last->next=NULL;

    return first;
}

void ispisi_listu(razlomak* first, char a)
{
    printf("%c= ", a);
    while(first){
        printf("%d/%d ", first->br, first->naz);
        first=first->next;
    }
    printf("\n\n");
}

void izbrisi_listu(razlomak* first)
{
    razlomak* pom;

    for(;first;first=pom){
        pom=first->next;
        free(first);
    }
}

int main(void)
{
    razlomak *a, *b, *c;

    a=stvori_listu(); //paziti da bude uzlazno sortiran
    ispisi_listu(a,'a');
    b=stvori_listu(); //paziti da bude uzlazno sortiran
    ispisi_listu(b,'b');

    c=unija(a,b);
    ispisi_listu(c,'c');

    izbrisi_listu(c);

    return 0;
}

